Index: branches/2012/dev_r3309_LOCEAN12_Ediag/NEMOGCM/NEMO/OPA_SRC/TRD/trdini.F90
===================================================================
--- branches/2012/dev_r3309_LOCEAN12_Ediag/NEMOGCM/NEMO/OPA_SRC/TRD/trdini.F90	(revision 3318)
+++ branches/2012/dev_r3309_LOCEAN12_Ediag/NEMOGCM/NEMO/OPA_SRC/TRD/trdini.F90	(revision 3318)
@@ -0,0 +1,96 @@
+MODULE trdini
+   !!======================================================================
+   !!                       ***  MODULE  trdini  ***
+   !! Ocean diagnostics:  ocean tracers and dynamic trends
+   !!=====================================================================
+   !! History :   3.5  !  2012-02  (G. Madec) add 3D trends output for T, S, U, V, PE and KE
+   !!----------------------------------------------------------------------
+
+   !!----------------------------------------------------------------------
+   !!   trd_init      : initialization step
+   !!----------------------------------------------------------------------
+   USE trd_oce        ! trends: ocean variables
+!   USE ldftra_oce     ! ocean active tracers lateral physics
+   USE trdglo         ! ocean bassin integral constraints properties
+   USE trdmld         ! ocean active mixed layer tracers trends 
+   USE trdvor         ! ocean vorticity trends 
+   USE in_out_manager ! I/O manager
+   USE lib_mpp        ! MPP library
+
+   IMPLICIT NONE
+   PRIVATE
+
+   PUBLIC   trd_init   ! called by nemogcm.F90 module
+
+   !! * Substitutions
+#  include "domzgr_substitute.h90"
+#  include "vectopt_loop_substitute.h90"
+   !!----------------------------------------------------------------------
+   !! NEMO/OPA 3.3 , NEMO Consortium (2010)
+   !! $Id$
+   !! Software governed by the CeCILL licence     (NEMOGCM/NEMO_CeCILL.txt)
+   !!----------------------------------------------------------------------
+CONTAINS
+
+   SUBROUTINE trd_init
+      !!----------------------------------------------------------------------
+      !!                  ***  ROUTINE trd_init  ***
+      !! 
+      !! ** Purpose :   Initialization of trend diagnostics
+      !!----------------------------------------------------------------------
+      NAMELIST/namtrd/ ln_dyn_trd, ln_KE_trd, ln_vor_trd, ln_dyn_mld,   &
+         &             ln_tra_trd, ln_PE_trd, ln_glo_trd, ln_tra_mld,   &
+         &             nn_trd , cn_trdrst_in , ln_trdmld_restart,       &
+         &             nn_ctls, cn_trdrst_out, ln_trdmld_instant, rn_ucf
+      !!----------------------------------------------------------------------
+
+      REWIND( numnam )
+      READ  ( numnam, namtrd )      ! namelist namtrd : trends diagnostic
+
+      IF(lwp) THEN                  ! control print
+         WRITE(numout,*)
+         WRITE(numout,*) ' trd_init : Momentum/Tracers trends'
+         WRITE(numout,*) ' ~~~~~~~~~~'
+         WRITE(numout,*) '   Namelist namtrd : set trends parameters'
+         WRITE(numout,*) '      global domain averaged dyn & tra trends        ln_glo_trd  = ', ln_glo_trd
+         WRITE(numout,*) '      U & V trends: 3D output                        ln_dyn_trd  = ', ln_dyn_trd
+         WRITE(numout,*) '      U & V trends: Mixed Layer averaged             ln_dyn_mld  = ', ln_dyn_mld
+         WRITE(numout,*) '      T & S trends: 3D output                        ln_tra_trd  = ', ln_tra_trd
+         WRITE(numout,*) '      T & S trends: Mixed Layer averaged             ln_tra_mld  = ', ln_tra_mld
+         WRITE(numout,*) '      Kinetic   Energy trends                        ln_KE_trd   = ', ln_KE_trd
+         WRITE(numout,*) '      Potential Energy trends                        ln_PE_trd   = ', ln_PE_trd
+         WRITE(numout,*) '      Barotropic vorticity trends                    ln_vor_trd  = ', ln_vor_trd
+         !
+         WRITE(numout,*) '      frequency of trends diagnostics (glo)   nn_trd             = ', nn_trd
+         WRITE(numout,*) '      control surface type            (mld)   nn_ctls            = ', nn_ctls
+         WRITE(numout,*) '      restart for ML diagnostics              ln_trdmld_restart  = ', ln_trdmld_restart
+         WRITE(numout,*) '      instantaneous or mean ML T/S            ln_trdmld_instant  = ', ln_trdmld_instant
+         WRITE(numout,*) '      unit conversion factor                  rn_ucf             = ', rn_ucf
+      ENDIF
+      !
+      !                             ! trend extraction flags  
+      l_trdtra = .FALSE.                                                       ! tracers  
+      IF ( ln_tra_trd .OR. ln_PE_trd .OR. ln_tra_mld .OR.   &
+         & ln_glo_trd                                       )   l_trdtra = .TRUE. 
+      !
+      l_trddyn = .FALSE.                                                       ! momentum
+      IF ( ln_dyn_trd .OR. ln_KE_trd .OR. ln_dyn_mld .OR.   &
+         & ln_vor_trd .OR. ln_glo_trd                       )   l_trddyn = .TRUE.
+      !
+      
+      IF( ln_KE_trd .OR. ln_PE_trd .OR. ln_dyn_mld )   &
+         CALL ctl_stop( 'KE, PE, aur ML on momentum are not yet coded we stop' )
+
+      !
+      IF( ln_glo_trd )    CALL trd_glo_init       ! integral constraints trends
+      IF( ln_tra_mld )    CALL trd_mld_init       ! mixed-layer trends (active  tracers)  
+      IF( ln_vor_trd )    CALL trd_vor_init       ! vorticity trends        
+      !
+!!gm  : Potential BUG : 3D output only for vector invariant form!  add a ctl_stop or code the flux form case
+!!gm  : bug/pb for vertical advection of tracer in vvl case: add T.dt[eta] in the output... 
+      !
+      !
+   END SUBROUTINE trd_init
+
+   !!======================================================================
+END MODULE trdini
Index: branches/2012/dev_r3309_LOCEAN12_Ediag/NEMOGCM/NEMO/OPA_SRC/TRD/trdmld.F90
===================================================================
--- branches/2012/dev_r3309_LOCEAN12_Ediag/NEMOGCM/NEMO/OPA_SRC/TRD/trdmld.F90	(revision 3317)
+++ branches/2012/dev_r3309_LOCEAN12_Ediag/NEMOGCM/NEMO/OPA_SRC/TRD/trdmld.F90	(revision 3318)
@@ -11,7 +11,5 @@
    !!                 !  05-05  (C. Deltel)     Diagnose trends of time averaged ML T & S
    !!----------------------------------------------------------------------
-#if   defined key_trdmld   ||   defined key_esopa
-   !!----------------------------------------------------------------------
-   !!   'key_trdmld'                          mixed layer trend diagnostics
+
    !!----------------------------------------------------------------------
    !!   trd_mld          : T and S cumulated trends averaged over the mixed layer
@@ -21,5 +19,5 @@
    USE oce             ! ocean dynamics and tracers variables
    USE dom_oce         ! ocean space and time domain variables
-   USE trdmod_oce      ! ocean variables trends
+   USE trd_oce         ! trends: ocean variables
    USE trdmld_oce      ! ocean variables trends
    USE ldftra_oce      ! ocean active tracers lateral physics
@@ -94,5 +92,4 @@
       !!            surface and the control surface is called "mixed-layer"
       !!----------------------------------------------------------------------
-      !
       INTEGER                         , INTENT( in ) ::   ktrd       ! ocean trend index
       CHARACTER(len=2)                , INTENT( in ) ::   ctype      ! 2D surface/bottom or 3D interior physics
@@ -112,12 +109,12 @@
       IF( icount == 1 ) THEN        
          !
-         tmltrd(:,:,:) = 0.e0    ;    smltrd(:,:,:) = 0.e0    ! <<< reset trend arrays to zero
+         tmltrd(:,:,:) = 0._wp    ;    smltrd(:,:,:) = 0._wp    ! <<< reset trend arrays to zero
          
          ! ... Set nmld(ji,jj) = index of first T point below control surf. or outside mixed-layer
          IF( nn_ctls == 0 ) THEN       ! * control surface = mixed-layer with density criterion 
             nmld(:,:) = nmln(:,:)    ! array nmln computed in zdfmxl.F90
-         ELSE IF( nn_ctls == 1 ) THEN  ! * control surface = read index from file 
+         ELSEIF( nn_ctls == 1 ) THEN   ! * control surface = read index from file 
             nmld(:,:) = nbol(:,:)
-         ELSE IF( nn_ctls >= 2 ) THEN  ! * control surface = model level
+         ELSEIF( nn_ctls >= 2 ) THEN   ! * control surface = model level
             nn_ctls = MIN( nn_ctls, jpktrd - 1 )
             nmld(:,:) = nn_ctls + 1
@@ -129,5 +126,5 @@
             ! Check of validity : nmld(ji,jj) <= jpktrd
             isum        = 0
-            zvlmsk(:,:) = 0.e0
+            zvlmsk(:,:) = 0._wp
 
             IF( jpktrd < jpk ) THEN 
@@ -138,5 +135,5 @@
                      ELSE
                         isum = isum + 1
-                        zvlmsk(ji,jj) = 0.
+                        zvlmsk(ji,jj) = 0._wp
                      ENDIF
                   END DO
@@ -157,5 +154,5 @@
          
          ! ... Weights for vertical averaging
-         wkx(:,:,:) = 0.e0
+         wkx(:,:,:) = 0._wp
          DO jk = 1, jpktrd             ! initialize wkx with vertical scale factor in mixed-layer
             DO jj = 1,jpj
@@ -166,5 +163,5 @@
          END DO
          
-         rmld(:,:) = 0.e0                ! compute mixed-layer depth : rmld
+         rmld(:,:) = 0._wp               ! compute mixed-layer depth : rmld
          DO jk = 1, jpktrd
             rmld(:,:) = rmld(:,:) + wkx(:,:,jk)
@@ -172,5 +169,5 @@
          
          DO jk = 1, jpktrd             ! compute integration weights
-            wkx(:,:,jk) = wkx(:,:,jk) / MAX( 1., rmld(:,:) )
+            wkx(:,:,jk) = wkx(:,:,jk) / MAX( 1._wp, rmld(:,:) )
          END DO
 
@@ -241,9 +238,6 @@
       !!       In IV), the appropriate trends are written in the trends NetCDF file.
       !!
-      !! References :
-      !!       - Vialard & al.
-      !!       - See NEMO documentation (in preparation)
-      !!----------------------------------------------------------------------
-      !
+      !! References :  Vialard et al.,2001, JPO.
+      !!----------------------------------------------------------------------
       INTEGER, INTENT( in ) ::   kt   ! ocean time-step index
       !
@@ -761,5 +755,5 @@
       ! -------------------------------------------------
 
-      IF( ( lk_trdmld ) .AND. ( MOD( nitend, nn_trd ) /= 0 ) ) THEN
+      IF( MOD( nitend, nn_trd ) /= 0 ) THEN
          WRITE(numout,cform_err)
          WRITE(numout,*) '                Your nitend parameter, nitend = ', nitend
@@ -774,10 +768,6 @@
       END IF
 
-      IF( ( lk_trdmld ) .AND. ( nn_cla == 1 ) ) THEN
-         WRITE(numout,cform_war)
-         WRITE(numout,*) '                You set n_cla = 1. Note that the Mixed-Layer diagnostics  '
-         WRITE(numout,*) '                are not exact along the corresponding straits.            '
-         nwarn = nwarn + 1
-      END IF
+      IF( nn_cla == 1 )   CALL ctl_warn( '      You set n_cla = 1. Note that the Mixed-Layer diagnostics  ',   &
+         &                               '      are not exact along the corresponding straits.            ')
 
       !                                   ! allocate trdmld arrays
@@ -951,30 +941,4 @@
    END SUBROUTINE trd_mld_init
 
-#else
-   !!----------------------------------------------------------------------
-   !!   Default option :                                       Empty module
-   !!----------------------------------------------------------------------
-CONTAINS
-   SUBROUTINE trd_mld( kt )             ! Empty routine
-      INTEGER, INTENT( in) ::   kt
-      WRITE(*,*) 'trd_mld: You should not have seen this print! error?', kt
-   END SUBROUTINE trd_mld
-   SUBROUTINE trd_mld_zint( pttrdmld, pstrdmld, ktrd, ctype )
-      REAL, DIMENSION(:,:,:), INTENT( in ) ::   &
-         pttrdmld, pstrdmld                   ! Temperature and Salinity trends
-      INTEGER, INTENT( in ) ::   ktrd         ! ocean trend index
-      CHARACTER(len=2), INTENT( in ) ::   &  
-         ctype                                ! surface/bottom (2D arrays) or
-         !                                    ! interior (3D arrays) physics
-      WRITE(*,*) 'trd_mld_zint: You should not have seen this print! error?', pttrdmld(1,1,1)
-      WRITE(*,*) '  "      "  : You should not have seen this print! error?', pstrdmld(1,1,1)
-      WRITE(*,*) '  "      "  : You should not have seen this print! error?', ctype
-      WRITE(*,*) '  "      "  : You should not have seen this print! error?', ktrd
-   END SUBROUTINE trd_mld_zint
-   SUBROUTINE trd_mld_init              ! Empty routine
-      WRITE(*,*) 'trd_mld_init: You should not have seen this print! error?'
-   END SUBROUTINE trd_mld_init
-#endif
-
    !!======================================================================
 END MODULE trdmld
Index: branches/2012/dev_r3309_LOCEAN12_Ediag/NEMOGCM/NEMO/OPA_SRC/TRD/trdmld_oce.F90
===================================================================
--- branches/2012/dev_r3309_LOCEAN12_Ediag/NEMOGCM/NEMO/OPA_SRC/TRD/trdmld_oce.F90	(revision 3317)
+++ branches/2012/dev_r3309_LOCEAN12_Ediag/NEMOGCM/NEMO/OPA_SRC/TRD/trdmld_oce.F90	(revision 3318)
@@ -5,4 +5,5 @@
    !!======================================================================
    !! History :  1.0  ! 2004-08  (C. Talandier)  New trends organization
+   !!            3.5  ! 2012-02  (G. Madec) suppress the trend keys
    !!----------------------------------------------------------------------
    USE par_oce        ! ocean parameters
@@ -13,11 +14,6 @@
    PUBLIC   trdmld_oce_alloc    ! Called in trdmld.F90
 
-#if defined key_trdmld
-   LOGICAL, PUBLIC, PARAMETER ::   lk_trdmld = .TRUE.    !: ML trend flag
-#else
-   LOGICAL, PUBLIC, PARAMETER ::   lk_trdmld = .FALSE.   !: ML trend flag
-#endif
-   !!* mixed layer trends indices
-   INTEGER, PARAMETER, PUBLIC ::   jpltrd = 11      !: number of mixed-layer trends arrays
+   !                                                !* mixed layer trend indices
+   INTEGER, PUBLIC, PARAMETER ::   jpltrd = 11      !: number of mixed-layer trends arrays
    INTEGER, PUBLIC            ::   jpktrd           !: max level for mixed-layer trends diag.
    !
@@ -35,8 +31,4 @@
    INTEGER, PUBLIC, PARAMETER ::   jpmld_atf = 11   !:  asselin trend (**MUST BE THE LAST ONE**)
 
-#if   defined  key_trdmld   ||   defined key_esopa
-   !!----------------------------------------------------------------------
-   !!   'key_trdmld'                         mixed layer trends diagnostics
-   !!----------------------------------------------------------------------
 
    !! Arrays used for diagnosing mixed-layer trends 
@@ -79,5 +71,5 @@
       smltrd_csum_ln,               & !:    ( idem for salinity )
       smltrd_csum_ub                  !: 
-#endif
+
    !!----------------------------------------------------------------------
    !! NEMO/OPA 4.0 , NEMO Consortium (2011)
@@ -101,5 +93,4 @@
      ierr(:) = 0
 
-#if   defined  key_trdmld   ||   defined key_esopa
      ALLOCATE( nmld(jpi,jpj), nbol(jpi,jpj),       &
         &      wkx(jpi,jpj,jpk), rmld(jpi,jpj),    & 
@@ -125,5 +116,4 @@
         &      tmltrd_csum_ub(jpi,jpj,jpltrd), smltrd_sum(jpi,jpj,jpltrd),     &
         &      smltrd_csum_ln(jpi,jpj,jpltrd), smltrd_csum_ub(jpi,jpj,jpltrd), STAT=ierr(5) )
-#endif
       !
       trdmld_oce_alloc = MAXVAL( ierr )
Index: branches/2012/dev_r3309_LOCEAN12_Ediag/NEMOGCM/NEMO/OPA_SRC/TRD/trdmld_rst.F90
===================================================================
--- branches/2012/dev_r3309_LOCEAN12_Ediag/NEMOGCM/NEMO/OPA_SRC/TRD/trdmld_rst.F90	(revision 3317)
+++ branches/2012/dev_r3309_LOCEAN12_Ediag/NEMOGCM/NEMO/OPA_SRC/TRD/trdmld_rst.F90	(revision 3318)
@@ -4,10 +4,13 @@
    !! Ocean dynamic :  Input/Output files for restart on mixed-layer diagnostics
    !!=================================================================================
-   !! History :  9.0  ! 05-05 (C. Deltel) Original code
+   !! History :  1.0  ! 2005-05 (C. Deltel)  Original code
    !!---------------------------------------------------------------------------------
-#if defined key_trdmld
+
+   !!---------------------------------------------------------------------------------
+   !!  trd_mld_rst_write : write mixed layer trend restart
+   !!  trd_mld_rst_read  : read  mixed layer trend restart
    !!---------------------------------------------------------------------------------
    USE dom_oce         ! ocean space and time domain
-   USE trdmod_oce      ! ocean variables for trend diagnostics (i.e. icp/mixed-layer/vorticity)
+   USE trd_oce         ! trends: ocean variables
    USE in_out_manager  ! I/O manager
    USE iom             ! I/O module
@@ -27,5 +30,4 @@
    !! Software governed by the CeCILL licence (NEMOGCM/NEMO_CeCILL.txt)
    !!---------------------------------------------------------------------------------
-  
 CONTAINS
   
@@ -92,6 +94,6 @@
          CALL iom_rstput( kt, nitrst, nummldw, 'tml_sumb'        , tml_sumb        )
          DO jk = 1, jpltrd
-            IF( jk < 10 ) THEN   ;   WRITE(charout,FMT="('tmltrd_csum_ub_', I1)") jk
-            ELSE                 ;   WRITE(charout,FMT="('tmltrd_csum_ub_', I2)") jk
+            IF( jk < 10 ) THEN   ;   WRITE(charout,FMT="('tmltrd_csum_ub_', I1)")   jk
+            ELSE                 ;   WRITE(charout,FMT="('tmltrd_csum_ub_', I2)")   jk
             ENDIF
             CALL iom_rstput( kt, nitrst, nummldw, charout,  tmltrd_csum_ub(:,:,jk) )
@@ -103,6 +105,6 @@
          CALL iom_rstput( kt, nitrst, nummldw, 'sml_sumb'        , sml_sumb        )
          DO jk = 1, jpltrd
-            IF( jk < 10 ) THEN   ;   WRITE(charout,FMT="('smltrd_csum_ub_', I1)") jk
-            ELSE                 ;   WRITE(charout,FMT="('smltrd_csum_ub_', I2)") jk
+            IF( jk < 10 ) THEN   ;   WRITE(charout,FMT="('smltrd_csum_ub_', I1)")   jk
+            ELSE                 ;   WRITE(charout,FMT="('smltrd_csum_ub_', I2)")   jk
             ENDIF
             CALL iom_rstput( kt, nitrst, nummldw, charout , smltrd_csum_ub(:,:,jk) )
@@ -116,93 +118,77 @@
       ENDIF
       ! 
-      !    
    END SUBROUTINE trd_mld_rst_write
 
 
    SUBROUTINE trd_mld_rst_read
-    !!----------------------------------------------------------------------------
-    !!                   ***  SUBROUTINE trd_mld_rst_lec  ***
-    !!                   
-    !! ** Purpose :   Read file for mixed-layer diagnostics restart.
-    !!----------------------------------------------------------------------------
-    INTEGER  ::  inum       ! temporary logical unit
-    !
-    CHARACTER (len=35) :: charout
-    INTEGER ::   jk         ! loop indice
-    INTEGER ::   jlibalt = jprstlib
-    LOGICAL ::   llok
-    !!-----------------------------------------------------------------------------
+      !!----------------------------------------------------------------------------
+      !!                   ***  SUBROUTINE trd_mld_rst_lec  ***
+      !!                   
+      !! ** Purpose :   Read file for mixed-layer diagnostics restart.
+      !!----------------------------------------------------------------------------
+      INTEGER  ::  inum       ! temporary logical unit
+      !
+      CHARACTER (len=35) :: charout
+      INTEGER ::   jk         ! loop indice
+      INTEGER ::   jlibalt = jprstlib
+      LOGICAL ::   llok
+      !!-----------------------------------------------------------------------------
 
-    IF(lwp)  THEN
-       WRITE(numout,*)
-       WRITE(numout,*) ' trd_mld_rst_read : read the NetCDF MLD restart file'
-       WRITE(numout,*) ' ~~~~~~~~~~~~~~~~'
-    ENDIF
-    IF ( jprstlib == jprstdimg ) THEN
-       ! eventually read netcdf file (monobloc)  for restarting on different number of processors
-       ! if {cn_trdrst_in}.nc exists, then set jlibalt to jpnf90
-       INQUIRE( FILE = TRIM(cn_trdrst_in)//'.nc', EXIST = llok )
-       IF ( llok ) THEN ; jlibalt = jpnf90  ; ELSE ; jlibalt = jprstlib ; ENDIF
-    ENDIF
+      IF(lwp)  THEN
+         WRITE(numout,*)
+         WRITE(numout,*) ' trd_mld_rst_read : read the NetCDF MLD restart file'
+         WRITE(numout,*) ' ~~~~~~~~~~~~~~~~'
+      ENDIF
+      IF ( jprstlib == jprstdimg ) THEN
+         ! eventually read netcdf file (monobloc)  for restarting on different number of processors
+         ! if {cn_trdrst_in}.nc exists, then set jlibalt to jpnf90
+         INQUIRE( FILE = TRIM(cn_trdrst_in)//'.nc', EXIST = llok )
+         IF ( llok ) THEN   ;   jlibalt = jpnf90   
+         ELSE               ;   jlibalt = jprstlib   
+         ENDIF
+      ENDIF
 
-    CALL iom_open( cn_trdrst_in, inum, kiolib = jlibalt ) 
+      CALL iom_open( cn_trdrst_in, inum, kiolib = jlibalt ) 
 
-    IF( ln_trdmld_instant ) THEN 
-       !-- Temperature
-       CALL iom_get( inum, jpdom_autoglo, 'tmlbb'           , tmlbb          )
-       CALL iom_get( inum, jpdom_autoglo, 'tmlbn'           , tmlbn          )
-       CALL iom_get( inum, jpdom_autoglo, 'tmlatfb'         , tmlatfb        )
-
-       !-- Salinity
-       CALL iom_get( inum, jpdom_autoglo, 'smlbb'           , smlbb          )
-       CALL iom_get( inum, jpdom_autoglo, 'smlbn'           , smlbn          )
-       CALL iom_get( inum, jpdom_autoglo, 'smlatfb'         , smlatfb        )
-    ELSE
-       CALL iom_get( inum, jpdom_autoglo, 'rmldbn'          , rmldbn         ) ! needed for rmld_sum
-
-       !-- Temperature
-       CALL iom_get( inum, jpdom_autoglo, 'tmlbn'           , tmlbn          ) ! needed for tml_sum
-       CALL iom_get( inum, jpdom_autoglo, 'tml_sumb'        , tml_sumb       )
-       DO jk = 1, jpltrd
-          IF( jk < 10 )   THEN
-             WRITE(charout,FMT="('tmltrd_csum_ub_', I1)") jk
-          ELSE
-             WRITE(charout,FMT="('tmltrd_csum_ub_', I2)") jk
-          ENDIF
-          CALL iom_get( inum, jpdom_autoglo, charout, tmltrd_csum_ub(:,:,jk) )
-       ENDDO
-       CALL iom_get( inum, jpdom_autoglo, 'tmltrd_atf_sumb' , tmltrd_atf_sumb)
-
-       !-- Salinity
-       CALL iom_get( inum, jpdom_autoglo, 'smlbn'           , smlbn          ) ! needed for sml_sum
-       CALL iom_get( inum, jpdom_autoglo, 'sml_sumb'        , sml_sumb       )
-       DO jk = 1, jpltrd
-          IF( jk < 10 )   THEN
-             WRITE(charout,FMT="('smltrd_csum_ub_', I1)") jk
-          ELSE
-             WRITE(charout,FMT="('smltrd_csum_ub_', I2)") jk
-          ENDIF
-          CALL iom_get( inum, jpdom_autoglo, charout, smltrd_csum_ub(:,:,jk) )
-       ENDDO
-       CALL iom_get( inum, jpdom_autoglo, 'smltrd_atf_sumb' , smltrd_atf_sumb)
-
-       CALL iom_close( inum )
-    ENDIF
-
-  END SUBROUTINE trd_mld_rst_read
+      IF( ln_trdmld_instant ) THEN 
+         !-- Temperature
+         CALL iom_get( inum, jpdom_autoglo, 'tmlbb'           , tmlbb          )
+         CALL iom_get( inum, jpdom_autoglo, 'tmlbn'           , tmlbn          )
+         CALL iom_get( inum, jpdom_autoglo, 'tmlatfb'         , tmlatfb        )
+         !
+         !-- Salinity
+         CALL iom_get( inum, jpdom_autoglo, 'smlbb'           , smlbb          )
+         CALL iom_get( inum, jpdom_autoglo, 'smlbn'           , smlbn          )
+         CALL iom_get( inum, jpdom_autoglo, 'smlatfb'         , smlatfb        )
+      ELSE
+         CALL iom_get( inum, jpdom_autoglo, 'rmldbn'          , rmldbn         ) ! needed for rmld_sum
+         !
+         !-- Temperature
+         CALL iom_get( inum, jpdom_autoglo, 'tmlbn'           , tmlbn          ) ! needed for tml_sum
+         CALL iom_get( inum, jpdom_autoglo, 'tml_sumb'        , tml_sumb       )
+         DO jk = 1, jpltrd
+            IF( jk < 10 ) THEN   ;   WRITE(charout,FMT="('tmltrd_csum_ub_', I1)")   jk
+            ELSE                 ;   WRITE(charout,FMT="('tmltrd_csum_ub_', I2)")   jk
+            ENDIF
+            CALL iom_get( inum, jpdom_autoglo, charout, tmltrd_csum_ub(:,:,jk) )
+         END DO
+         CALL iom_get( inum, jpdom_autoglo, 'tmltrd_atf_sumb' , tmltrd_atf_sumb)
+         !
+         !-- Salinity
+         CALL iom_get( inum, jpdom_autoglo, 'smlbn'           , smlbn          ) ! needed for sml_sum
+         CALL iom_get( inum, jpdom_autoglo, 'sml_sumb'        , sml_sumb       )
+         DO jk = 1, jpltrd
+            IF( jk < 10 ) THEN   ;   WRITE(charout,FMT="('smltrd_csum_ub_', I1)")   jk
+            ELSE                 ;   WRITE(charout,FMT="('smltrd_csum_ub_', I2)")   jk
+            ENDIF
+            CALL iom_get( inum, jpdom_autoglo, charout, smltrd_csum_ub(:,:,jk) )
+         END DO
+         CALL iom_get( inum, jpdom_autoglo, 'smltrd_atf_sumb' , smltrd_atf_sumb)
+         !
+         CALL iom_close( inum )
+      ENDIF
+      !
+   END SUBROUTINE trd_mld_rst_read
   
-#else
-  !!=================================================================================
-  !!                       ***  MODULE  trdmld_rst  ***
-  !! Ocean dynamic :  Input/Output files for restart on mixed-layer diagnostics
-  !!=================================================================================
-CONTAINS
-  SUBROUTINE trd_mld_rst_write( kt )           !  No ML diags ==> empty routine
-    WRITE(*,*) 'trd_mld_rst_wri: You should not have seen this print! error?', kt
-  END SUBROUTINE trd_mld_rst_write
-  SUBROUTINE trd_mld_rst_read                  !  No ML Diags ==> empty routine
-  END SUBROUTINE trd_mld_rst_read
-#endif
-
   !!=================================================================================
 END MODULE trdmld_rst
